from lib_wuerfel import Wuerfel
import os
from lib_brueche import Bruchrechner

def createHtmlFile(w,z,m,res):
    su=0
    sorted=[]
    br=Bruchrechner()
    for t in res:
        su=su+res[t]
        sorted.append(t)
    sorted.sort()
    f=open("html/wu_%d_%d_%d.html"%(w,z,m),"w")
    f.write("<HTML>\n")
    f.write("<HEAD>\n")
    f.write("<TITLE> Wahrscheinlichkeiten bei W%d, %d z&auml;hlende von %d</TITLE>\n"%(w,z,m))
    f.write("<style> td.upper_line { border-top:solid 1px black; } table.fraction { text-align: center; vertical-align: middle; margin-top:0.5em; margin-bottom:0.5em; line-height: 2em; } </style>")
    f.write("</HEAD>\n")
    f.write("<BODY>\n")
    f.write("<p> <a href=\"uebersicht_w%d.html\"> &Uuml;bersicht W%d</a> | <a href=\"index.html\"> Gesamt&uuml;bersicht </a> </p>"%(w,w))
    if (z>1):
        f.write("<h1> Verteilung W%d, %d werden gew&uuml;rfelt, %d davon z&auml;hlen </h1>\n"%(w,m,z))
    else:
        f.write("<h1> Verteilung W%d, %d werden gew&uuml;rfelt, der h&ouml;chste davon z&auml;hlt </h1>\n"%(w,m))
    f.write("<p>\n")
    f.write("<table border=1>\n")
    f.write("<tr> <th> Resultat </th> <th> Wahrscheinlichkeit als Bruch </th> <th> Approximierte Wahrscheinlichkeit in Prozent </th> </tr>")
    for t in sorted:
        bruch=[res[t],su]
        bruch=br.kuerzen(bruch)
        table="<table class=\"fraction\" align=\"center\" cellpadding=\"0\" cellspacing=\"0\"> <tr> <td> %d </td> </tr> <tr> <td class=\"upper_line\"> %d </td> </tr> </table>"%(bruch[0],bruch[1])
        proz=100.0*bruch[0]/bruch[1]
        f.write("<tr> <td> %d </td> <td> %s </td> <td> %.2f %% </td> </tr> \n"%(t,table,proz))
    f.write("</table>\n")
    f.write("</p>\n")
    f.write("<hr\>\n")
    f.write("<p> <a href=\"uebersicht_w%d.html\"> &Uuml;bersicht W%d</a> | <a href=\"index.html\"> Gesamt&uuml;bersicht </a> </p>"%(w,w))
    f.write("</BODY>\n")
    f.write("</HTML>\n")
    f.close()


tin=open("html/index.html","w")
tin.write("<HTML>\n")
tin.write("<HEAD>\n")
tin.write("<TITLE> Wahrscheinlichkeiten von W&uuml;rfelergebnissen, bei denen nur die besten z&auml;hlen</TITLE>\n")
tin.write("</HEAD>\n")
tin.write("<BODY>\n")
tin.write("<h1> Wahrscheinlichkeiten von W&uuml;rfelergebnissen, bei denen nur die besten z&auml;hlen</h1>\n")
tin.write("<h2> W&auml;hle den W&uuml;rfel: </h2>")
for w in (4,6,8,10,12,20):
    tin.write("<p> <a href=\"uebersicht_w%d.html\"> W%d </a> </p>"%(w,w))
    fin=open("html/uebersicht_w%d.html"%w,"w")
    fin.write("<HTML>\n")
    fin.write("<HEAD>\n")
    fin.write("<TITLE> Wahrscheinlichkeiten von W&uuml;rfelergebnissen mit W%d, bei denen nur die besten z&auml;hlen f&uum</TITLE>\n"%(w))
    fin.write("</HEAD>\n")
    fin.write("<BODY>\n")
    fin.write("<h1> Wahrscheinlichkeiten von W&uuml;rfelergebnissen mit W%d, bei denen nur die besten z&auml;hlen</h1>\n"%(w))
    fin.write("<p> <a href=\"index.html\"> Zur&uuml;ck zur Gesamt&uuml;bersicht </a> </p>\n")
    fin.write("<h2> W&auml;hle die Kombination: </h2>")
    fin.write("<table border=1>\n")
    zs=[]
    zhd="<tr> <th> Anzahl W&uuml;rfel </th> "
    for z in range(1,6):
        zhd=zhd+"<th> Z&auml;hlend %d </th> "%z
        wu=Wuerfel(w,z,z)
        wu.create_basic_data()
        wu.zaehlen()
        for m in range(z,51):
            print "W%d, Zaehlend %d, Max %d"%(w,z,m)
            createHtmlFile(w,z,m,wu.getResultate())
            if (z==1):
                mz="<tr> <td> %d </td> "%m
                for t in range(1,6):
                    mz=mz+"<td> "
                    if (m>=t):
                        mz=mz+"<a href=\"wu_%d_%d_%d.html\"> W%d, Z %d, M %d </a>"%(w,t,m,w,t,m)
                    else:
                        mz=mz+" -- nix --"
                    mz=mz+"</td> "
                mz=mz+"</tr>"
                zs.append(mz)
            wu.durchgang()
    fin.write(zhd)
    for z in zs:
        fin.write(z+"\n")
    fin.write("</table>\n")
    fin.write("</BODY>\n")
    fin.write("</HTML>\n")
    fin.close()
tin.write("</BODY>\n")
tin.write("</HTML>\n")
tin.close()
