
import sys

#WUERFELART=sys.argv[1]
#ZAEHLEND=sys.argv[2]
#MAX=sys.argv[3]

class Wuerfel:

    def __init__(self,wuerfelart,zaehlend,max):
        self.klassen=[]
        self.wuerfelart=wuerfelart
        self.wp1=wuerfelart+1
        self.zaehlend=zaehlend
        self.max=max
        self.outputLevel=3
        self.leveloutput=False

    def setOutput(self,level,leveloutput=False):
        self.leveloutput=leveloutput
        self.outputLevel=level

    def calculate(self):
        self.create_basic_data()
        self.diceCount()

    def output(self,was,level=1):
        if (self.outputLevel>=level):
            if (self.leveloutput):
                print ("Level %d: %s"(level,was))
            else:
                print (was)

    def copy(self,liste):
        erg=[]
        for t in liste:
            erg.append(t)
        return erg

    def codeBuchstabe(self,zuCodieren):
        return "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ"[zuCodieren]

    def encode(self,zuCodieren):
        res=""
        for t in zuCodieren:
            res=res+self.codeBuchstabe(t)
        return res

    def create_basic_data(self):
        self.output("Erzeuge Basisdaten",2)
        raw=[[]]
        for i in range(self.zaehlend):
            rawappend=[]
            for t in range(1,self.wp1):
                for q in raw:
                    nl=self.copy(q)
                    nl.append(t)
                    rawappend.append(nl)
            raw=rawappend
        self.output("Rohdaten: %d Elemente"%len(raw))
        self.data={}
        for i in raw:
            min=100000
            sum=0
            nr=0
            for t in i:
                if t<min:
                    min=t
                    mip=nr
                nr=nr+1
                sum=sum+t
            code=self.encode(i)
            targets={}
            for q in range(1,self.wp1):
                if (q<min):
                    targets[q]=code
                else:
                    newtar=self.copy(i)
                    newtar[mip]=q
                    codetar=self.encode(newtar)
                    targets[q]=codetar
            self.data[code]=[i,sum,1,0,targets]
        self.output("Erweiterte Rohdaten erzeugt")

    def diceCount(self):
        self.output("Beginne Durchgaenge",3)
        for durchgaenge in range(self.max-self.zaehlend):
            self.durchgang()
        self.zaehlen()

    def durchgang(self):
        for t in self.data:
            for u in range(1,self.wp1):
                target=self.data[t][4][u]
                self.data[target][3]=self.data[target][3]+self.data[t][2]
        for t in self.data:
            self.data[t][2]=self.data[t][3]
            self.data[t][3]=0
        self.zaehlen()

    def zaehlen(self):
        self.output("Beginne Zaehlen",3)
        count={}
        for t in self.data:
            su=self.data[t][1]
            cn=self.data[t][2]
            if (su in count):
                count[su]=count[su]+cn
            else:
                count[su]=cn
        self.output("Zaehlen beendet")
        self.count=count


    def getResultate(self):
        return self.count

    def printResults(self):
        self.output("Ergebnisse")
        res=[]
        sum=0
        count=self.count
        for t in count:
            res.append(t)
            sum=sum+count[t]
        res.sort()
        for q in res:
            print q,count[q],100.0*count[q]/sum
